diff --git a/game/core/src/main/java/net/minecraft/core/entity/Entity.java b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
index fa2f5ad7f..d04a9eb6d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Entity.java
@@ -49,7 +49,7 @@ public abstract class Entity
     public boolean blocksBuilding = false;
     public @Nullable Entity passenger;
     public @Nullable IVehicle vehicle;
-    public @Nullable World world;
+    public @NotNull World world;
     public double xo;
     public double yo;
     public double zo;
@@ -117,7 +117,8 @@ public abstract class Entity
     public boolean sendAdditionalData = false;
     public boolean turnWithVehicle = true;
 
-    public Entity(final @Nullable World world) {
+    public Entity(final @NotNull World world) {
+        assert world != null : "Entity world must not be null! If no world ref available try using WorldClient.EMPTY_WORLD as a stub!";
         this.world = world;
         setPos(0.0D, 0.0D, 0.0D);
         entityData.define(DATA_SHARED_FLAGS_ID, (byte) 0, Byte.class);
@@ -381,7 +382,7 @@ public abstract class Entity
     }
 
     public void waterHurt() {
-        if (world != null && world.dimension == Dimension.NETHER && !(vehicle instanceof EntityBoat)) {
+        if (world.dimension == Dimension.NETHER && !(vehicle instanceof EntityBoat)) {
             hurt(null, 1, DamageType.FIRE);
         }
     }
@@ -867,7 +868,7 @@ public abstract class Entity
         double d = (bb.maxY - bb.minY) * 0.66D;
         int j = MathHelper.floor((y - (double) heightOffset) + d);
         int k = MathHelper.floor(z);
-        if(world != null && world.areBlocksLoaded(MathHelper.floor(bb.minX), MathHelper.floor(bb.minY), MathHelper.floor(bb.minZ), MathHelper.floor(bb.maxX), MathHelper.floor(bb.maxY), MathHelper.floor(bb.maxZ)))
+        if(world.areBlocksLoaded(MathHelper.floor(bb.minX), MathHelper.floor(bb.minY), MathHelper.floor(bb.minZ), MathHelper.floor(bb.maxX), MathHelper.floor(bb.maxY), MathHelper.floor(bb.maxZ)))
         {
             float f1 = world.getLightBrightness(i, j, k);
             if(f1 < entityBrightness)
@@ -899,7 +900,7 @@ public abstract class Entity
     	return world.getLightmapCoord(skylight, blocklight);
     }
 
-    public void setWorld(@Nullable World world)
+    public void setWorld(@NotNull final World world)
     {
         this.world = world;
     }
@@ -1049,19 +1050,19 @@ public abstract class Entity
     {
     }
 
-    public boolean shouldRender(Vec3 vec3)
+    public boolean shouldRender(final Vec3 vec3, final double viewDistanceModifier)
     {
-        double d = x - vec3.x;
-        double d1 = y - vec3.y;
-        double d2 = z - vec3.z;
-        double d3 = d * d + d1 * d1 + d2 * d2;
-        return shouldRenderAtSqrDistance(d3);
+        final double dx = this.x - vec3.x;
+        final double dy = this.y - vec3.y;
+        final double dz = this.z - vec3.z;
+        final double distance = dx * dx + dy * dy + dz * dz;
+        return shouldRenderAtSqrDistance(distance, viewDistanceModifier);
     }
 
-    public boolean shouldRenderAtSqrDistance(double distance)
+    public boolean shouldRenderAtSqrDistance(final double distance, final double viewDistanceModifier)
     {
-        double d1 = bb.getSize();
-        d1 *= 64D * viewScale;
+        double d1 = this.bb.getSize();
+        d1 *= 64D * this.viewScale * viewDistanceModifier;
         return distance < d1 * d1;
     }
 
@@ -1182,11 +1183,9 @@ public abstract class Entity
 
     public @NotNull EntityItem dropItem(@NotNull ItemStack itemStack, float verticalOffset)
     {
-        EntityItem entityitem = new EntityItem(world, x, y + verticalOffset, z, itemStack);
+        final EntityItem entityitem = new EntityItem(world, x, y + verticalOffset, z, itemStack);
         entityitem.pickupDelay = 10;
-        if (world != null) {
-            world.entityJoinedWorld(entityitem);
-        }
+        this.world.entityJoinedWorld(entityitem);
         return entityitem;
     }
 
@@ -1322,22 +1321,20 @@ public abstract class Entity
     {
         setPos(x, y, z);
         setRot(yRot, xRot);
-        if (world != null) {
-            List<AABB> cubes = world.getCubes(this, bb.getInsetBoundingBox(0.03125D, 0.0D, 0.03125D));
-            if(!cubes.isEmpty())
+        List<AABB> cubes = world.getCubes(this, bb.getInsetBoundingBox(0.03125D, 0.0D, 0.03125D));
+        if(!cubes.isEmpty())
+        {
+            double d3 = 0.0D;
+            for (AABB cube : cubes)
             {
-                double d3 = 0.0D;
-                for (AABB cube : cubes)
+                if (cube.maxY > d3)
                 {
-                    if (cube.maxY > d3)
-                    {
-                        d3 = cube.maxY;
-                    }
+                    d3 = cube.maxY;
                 }
-
-                y += d3 - bb.minY;
-                setPos(x, y, z);
             }
+
+            y += d3 - bb.minY;
+            setPos(x, y, z);
         }
     }
 
@@ -1384,6 +1381,10 @@ public abstract class Entity
 
     }
 
+    public @Nullable ICarriable getHeldObject() {
+        return null;
+    }
+
     public boolean isOnFire()
     {
         return !fireImmune && remainingFireTicks > 0 || getSharedFlag(FLAG_ONFIRE);
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
index 5c6051b24..803f01fe1 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityDispatcher.java
@@ -3,6 +3,7 @@ package net.minecraft.core.entity;
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.entity.animal.*;
 import net.minecraft.core.entity.monster.*;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.entity.projectile.*;
 import net.minecraft.core.entity.vehicle.EntityBoat;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
@@ -106,7 +107,7 @@ public final class EntityDispatcher
         return numericIdToStringIdMap;
     }
 
-    public static @Nullable Entity createEntityInWorld(@Nullable String id, World world)
+    public static @Nullable Entity createEntityInWorld(@Nullable final String id, @NotNull final World world)
     {
         if (id == null) return null;
         if (Legacy.isLegacyKey(id)) { // Handle entity creation via legacy id
@@ -121,11 +122,11 @@ public final class EntityDispatcher
         }
     }
 
-    public static @Nullable Entity createEntityInWorld(NamespaceID id, World world) {
+    public static @Nullable Entity createEntityInWorld(@NotNull final NamespaceID id, @NotNull final World world) {
         return createEntityInWorld(classForId(id), world);
     }
 
-    public static @Nullable Entity createEntityInWorld(Class<? extends Entity> clazz, World world) {
+    public static @Nullable Entity createEntityInWorld(@Nullable final Class<? extends Entity> clazz, @NotNull final World world) {
         Entity entity = null;
         try {
             if(clazz != null) {
@@ -195,8 +196,9 @@ public final class EntityDispatcher
         addMapping(ProjectileFireball.class, new NamespaceID("minecraft", "fireball"));
         addMapping(ProjectileCannonball.class, new NamespaceID("minecraft", "cannonball"));
 
-//        addMapping(Mob.class, new NamespaceID("minecraft", "mob")); // Abstract class, shouldn't ever be instantiated
+        addMapping(Mob.class, new NamespaceID("minecraft", "mob")); // Abstract class, shouldn't ever be instantiated
         addMapping(MobHuman.class, new NamespaceID("minecraft", "human"));
+        addMapping(Player.class, new NamespaceID("minecraft", "player"));
 
         // Hostile
         addMapping(MobZombie.class, new NamespaceID("minecraft", "zombie"), "guidebook.section.mob.zombie.name");
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
index bf284fd56..5e37c36ed 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityFishingBobber.java
@@ -92,10 +92,10 @@ public class EntityFishingBobber extends Entity
     }
 
     @Override
-	public boolean shouldRenderAtSqrDistance(double distance)
+	public boolean shouldRenderAtSqrDistance(double distance, double viewDistanceModifier)
     {
         double d1 = bb.getSize() * 4D;
-        d1 *= 64D;
+        d1 *= 64D * viewDistanceModifier;
         return distance < d1 * d1;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
index cd2cc068a..b08216347 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/EntityLightning.java
@@ -117,7 +117,7 @@ public class EntityLightning extends Entity
     }
 
     @Override
-	public boolean shouldRender(Vec3 vec3)
+	public boolean shouldRender(Vec3 vec3, double viewDistanceModifier)
     {
         return life >= 0;
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/Mob.java b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
index f7d6a20ad..a67b4fb3e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/Mob.java
@@ -35,6 +35,7 @@ import java.util.Map;
 
 public abstract class Mob extends Entity
 {
+    public static boolean SPAWN_NO_AI = false;
     public static final int DATA_VARIANT = 1;
     public static final int DATA_HEALTH = 2;
     protected @NotNull Map<ItemFood, ConsumedFood> consumedFood = new HashMap<>();
@@ -68,6 +69,7 @@ public abstract class Mob extends Entity
     public float prevCameraPitch;
     public float cameraPitch;
     protected boolean dead;
+    public boolean noAI = false;
     //    public int modelNum;
 //    public float animSpeed;
     public float walkAnimSpeedO;
@@ -94,8 +96,11 @@ public abstract class Mob extends Entity
     protected int numTicksToChaseTarget;
     public @NotNull String nickname = "";
     public byte chatColor = 0;
-    protected @NotNull NamespaceID textureIdentifier = new NamespaceID("minecraft", "char");
     protected float lastStrafe = 0.0f;
+    protected @NotNull String basePath = "/assets/minecraft/textures/entity/char/";
+    protected @NotNull String defaultTexture = "/assets/minecraft/textures/entity/char/0.png";
+    protected @NotNull String variantJsonPath = "/assets/minecraft/textures/entity/char/variant.json";
+    protected @NotNull NamespaceID textureIdentifier = new NamespaceID("minecraft", "char");
 
     public boolean isSkating = false;
 
@@ -105,7 +110,7 @@ public abstract class Mob extends Entity
     public @NotNull PlacementMode placementModeOverride = PlacementMode.FACING;
     public final @NotNull List<WeightedRandomLootObject> mobDrops = new ArrayList<>();
 
-    public Mob(@Nullable World world)
+    public Mob(@NotNull final World world)
     {
         super(world);
         heartsHalvesLife = 20;
@@ -145,7 +150,16 @@ public abstract class Mob extends Entity
 
         speed = 0.1f;
         flySpeed = 0.02f;
+        this.noAI = SPAWN_NO_AI;
     }
+
+    protected void setTextureIdentifier(final  @NotNull String namespace, final @NotNull String id) {
+        this.textureIdentifier = new NamespaceID(namespace, id);
+        this.basePath = String.format("/assets/%s/textures/entity/%s/", this.textureIdentifier.namespace, this.textureIdentifier.value);
+        this.defaultTexture = this.basePath + "0.png";
+        this.variantJsonPath = this.basePath + "variants.json";
+    }
+
     @Override
 	protected void defineSynchedData()
     {
@@ -157,34 +171,31 @@ public abstract class Mob extends Entity
     }
 
     @Override
-	public String getEntityTexture() {
-        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
-        return basePath + getTextureReference() + ".png";
+	public @NotNull String getEntityTexture() {
+        return this.basePath + getTextureReference() + ".png";
     }
 
     public String getTextureReference() {
-        SkinVariantList variantList = Global.accessor.getSkinVariantList();
-        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
-        return variantList.getSkinReference(basePath + "variants.json", "0", getSkinVariant());
+        final SkinVariantList variantList = Global.accessor.getSkinVariantList();
+        return variantList.getSkinReference(this.variantJsonPath, "0", getSkinVariant());
     }
 
     public boolean cycleVariant() {
-        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
-        int skinVar = getSkinVariant();
-        setSkinVariant(Global.accessor.getSkinVariantList().nextSkinVariant(basePath + "variants.json", skinVar));
+        final int skinVar = getSkinVariant();
+        setSkinVariant(Global.accessor.getSkinVariantList().nextSkinVariant(this.variantJsonPath, skinVar));
         return skinVar != getSkinVariant();
     }
 
     public int getSkinVariant() {
-        return Byte.toUnsignedInt(entityData.getByte(DATA_VARIANT));
+        return Byte.toUnsignedInt(this.entityData.getByte(DATA_VARIANT));
     }
 
-    public void setSkinVariant(int skinVariant) {
-        entityData.set(DATA_VARIANT, (byte) (skinVariant));
+    public void setSkinVariant(final int skinVariant) {
+        this.entityData.set(DATA_VARIANT, (byte) (skinVariant));
     }
 
     public @NotNull String getDefaultEntityTexture() {
-        return String.format("/assets/%s/textures/entity/%s/0.png", textureIdentifier.namespace, textureIdentifier.value);
+        return this.defaultTexture;
     }
 
     @Override
@@ -405,6 +416,7 @@ public abstract class Mob extends Entity
 	public void tick()
     {
         super.tick();
+        if (this.noAI) return;
         onLivingUpdate();
         double d = x - xo;
         double d1 = z - zo;
@@ -925,31 +937,33 @@ public abstract class Mob extends Entity
     }
 
     @Override
-	public void addAdditionalSaveData(@NotNull CompoundTag tag)
+	public void addAdditionalSaveData(@NotNull final CompoundTag tag)
     {
         tag.putShort("Health", (short)getHealth());
-        tag.putShort("HurtTime", (short)hurtTime);
-        tag.putShort("DeathTime", (short)deathTime);
-        tag.putShort("AttackTime", (short)attackTime);
-        tag.putString("Nickname", nickname);
-        tag.putByte("ChatColor", chatColor);
-        tag.putByte("SkinVariant", entityData.getByte(1));
+        tag.putShort("HurtTime", (short) this.hurtTime);
+        tag.putShort("DeathTime", (short) this.deathTime);
+        tag.putShort("AttackTime", (short) this.attackTime);
+        tag.putString("Nickname", this.nickname);
+        tag.putByte("ChatColor", this.chatColor);
+        tag.putByte("SkinVariant", this.entityData.getByte(1));
+        tag.putBoolean("noAI", this.noAI);
     }
 
     @Override
-	public void readAdditionalSaveData(@NotNull CompoundTag tag)
+	public void readAdditionalSaveData(@NotNull final CompoundTag tag)
     {
         setHealthRaw(tag.getShort("Health"));
         if(!tag.containsKey("Health"))
         {
             setHealthRaw(getMaxHealth());
         }
-        hurtTime = tag.getShort("HurtTime");
-        deathTime = tag.getShort("DeathTime");
-        attackTime = tag.getShort("AttackTime");
-        nickname = StringUtils.substring(tag.getString("Nickname"), 0, 32);
-        chatColor = tag.getByte("ChatColor");
+        this.hurtTime = tag.getShort("HurtTime");
+        this.deathTime = tag.getShort("DeathTime");
+        this.attackTime = tag.getShort("AttackTime");
+        this.nickname = StringUtils.substring(tag.getString("Nickname"), 0, 32);
+        this.chatColor = tag.getByte("ChatColor");
         setSkinVariant(tag.getByte("SkinVariant"));
+        this.noAI = tag.getBoolean("noAI");
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java b/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java
index 9691b3cfb..011d9d5e3 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobFlying.java
@@ -7,7 +7,7 @@ import net.minecraft.core.world.World;
 public class MobFlying extends Mob
 {
 
-    public MobFlying(World world)
+    public MobFlying(final World world)
     {
         super(world);
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
index ec5ed1e64..e041b0552 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/MobPathfinder.java
@@ -19,7 +19,7 @@ public abstract class MobPathfinder extends Mob
     protected @Nullable Entity closestFireflyEntity;
     protected boolean hasAttacked;
 
-    public MobPathfinder(@Nullable World world)
+    public MobPathfinder(@NotNull final World world)
     {
         super(world);
         hasAttacked = false;
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
index dea7bdc18..3fb849bf9 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobButterfly.java
@@ -16,6 +16,7 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.biome.Biome;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 import java.util.Arrays;
@@ -56,7 +57,7 @@ public class MobButterfly extends MobFlying implements Creature {
 
     public MobButterfly(World world) {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "butterfly");
+        setTextureIdentifier("minecraft", "butterfly");
         setSize(0.5f, 0.5f);
     }
 
@@ -251,33 +252,26 @@ public class MobButterfly extends MobFlying implements Creature {
     }
 
     @Override
-    public void addAdditionalSaveData(CompoundTag tag) {
+    public void addAdditionalSaveData(@NotNull CompoundTag tag) {
         super.addAdditionalSaveData(tag);
         tag.putByte("Color", (byte) getColor());
     }
 
     @Override
-    public void readAdditionalSaveData(CompoundTag tag) {
+    public void readAdditionalSaveData(@NotNull CompoundTag tag) {
         super.readAdditionalSaveData(tag);
         setColor(tag.getByte("Color") & 0xFF);
     }
 
     @Override
-    public String getEntityTexture() {
-        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
-        return basePath + getTextureReference() + "_0.png";
-//        if ((tickCount / 10) % 2 == 0) {
-//            return basePath + getTextureReference() + "_0.png";
-//        } else {
-//            return basePath + getTextureReference() + "_1.png";
-//        }
+    public @NotNull String getEntityTexture() {
+        return this.basePath + getTextureReference() + "_0.png";
     }
 
     @Override
     public String getTextureReference() {
-        SkinVariantList variantList = Global.accessor.getSkinVariantList();
-        String basePath = String.format("/assets/%s/textures/entity/%s/", textureIdentifier.namespace, textureIdentifier.value);
-        return colorEntries.get(getColor()).name + "/" + variantList.getSkinReference(basePath + "variants.json", "0", getSkinVariant());
+        final SkinVariantList variantList = Global.accessor.getSkinVariantList();
+        return colorEntries.get(getColor()).name + "/" + variantList.getSkinReference(variantJsonPath, "0", getSkinVariant());
     }
 
     public static class ButterflyEntry {
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobChicken.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobChicken.java
index ade3fc055..d42023c55 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobChicken.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobChicken.java
@@ -24,7 +24,7 @@ public class MobChicken extends MobAnimal
         flap = 0.0F;
         flapSpeed = 0.0F;
         flapping = 1.0F;
-        textureIdentifier = new NamespaceID("minecraft", "chicken");
+        setTextureIdentifier("minecraft", "chicken");
         setSize(0.4F, 0.8F);
         eggTimer = random.nextInt(6000) + 6000;
         mobDrops.add(new WeightedRandomLootObject(Items.FEATHER_CHICKEN.getDefaultStack(), 0, 2));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
index 6be859029..fc904f58d 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobCow.java
@@ -17,7 +17,7 @@ public class MobCow extends MobAnimal
     public MobCow(World world)
     {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "cow");
+        setTextureIdentifier("minecraft", "cow");
         setSize(0.9F, 1.3F);
         mobDrops.add(new WeightedRandomLootObject(Items.LEATHER.getDefaultStack(), 1, 5));
     }
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
index fd68f598f..6ccccf7c2 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobFireflyCluster.java
@@ -40,10 +40,10 @@ public class MobFireflyCluster extends MobFlying
     private int slowUpdateCooldown;
     
     
-    public MobFireflyCluster(World world)
+    public MobFireflyCluster(@NotNull final World world)
     {
         super(world);
-        if(world == null || world.isClientSide) {
+        if(world.isClientSide) {
         	setClusterSize(0);
         	setFireflyCount(0);
         }else {
@@ -57,9 +57,7 @@ public class MobFireflyCluster extends MobFlying
         fireImmune = true;
         
         // Give it a random cooldown so that not every check happens at the same time
-		if (world != null) {
-			slowUpdateCooldown = world.rand.nextInt(slowUpdateCooldownMax);
-		}
+        slowUpdateCooldown = world.rand.nextInt(slowUpdateCooldownMax);
     }
 
 	@Override
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
index 5f37a5ba2..800b23e3a 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobPig.java
@@ -24,7 +24,7 @@ public class MobPig extends MobAnimal
     public MobPig(World world)
     {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "pig");
+        setTextureIdentifier("minecraft", "pig");
         setSize(0.9F, 0.9F);
         mobDrops.add(new WeightedRandomLootObject(Items.FOOD_PORKCHOP_RAW.getDefaultStack(), 1, 2));
         burningMobDrops.add(new WeightedRandomLootObject(Items.FOOD_PORKCHOP_COOKED.getDefaultStack(), 1, 2));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
index 12eed6b10..a45ebe472 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSheep.java
@@ -28,7 +28,7 @@ public class MobSheep extends MobAnimal
     public MobSheep(World world)
     {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "sheep");
+        setTextureIdentifier("minecraft", "sheep");
         setSize(0.9F, 1.3F);
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
index 42dbead8a..1754fe698 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobSquid.java
@@ -44,7 +44,7 @@ public class MobSquid extends MobWaterAnimal
         tx = 0.0F;
         ty = 0.0F;
         tz = 0.0F;
-        textureIdentifier = new NamespaceID("minecraft", "squid");
+        setTextureIdentifier("minecraft", "squid");
         setSize(0.95F, 0.95F);
         tentacleSpeed = (1.0F / (random.nextFloat() + 1.0F)) * 0.2F;
         mobDrops.add(new WeightedRandomLootObject(Items.DYE.getDefaultStack(), 1, 3));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
index e1018d96b..39dd8a85e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/animal/MobWolf.java
@@ -58,7 +58,7 @@ public class MobWolf extends MobAnimal implements IItemHolding
     {
         super(world);
         looksWithInterest = false;
-        textureIdentifier = new NamespaceID("minecraft", "wolf");
+        setTextureIdentifier("minecraft", "wolf");
         setSize(0.8F, 0.8F);
         moveSpeed = 1.1F;
         scoreValue = 500;
@@ -87,8 +87,9 @@ public class MobWolf extends MobAnimal implements IItemHolding
 
     public @Nullable ArmorMaterial getArmorMaterial() {
         ArmorMaterial material = null;
-        String name = entityData.getString(DATA_ARMOR_MATERIAL);
-        for (ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
+        final String name = this.entityData.getString(DATA_ARMOR_MATERIAL);
+        if (name == null) return null;
+        for (final ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
             if (mat.identifier.toString().equalsIgnoreCase(name)) {
                 material = mat;
                 break;
@@ -98,16 +99,16 @@ public class MobWolf extends MobAnimal implements IItemHolding
         return material;
     }
 
-    public void setArmor(ItemStack stack) {
+    public void setArmor(final ItemStack stack) {
         ArmorMaterial material = null;
-        armor = stack;
+        this.armor = stack;
         if (stack != null && stack.getItem() instanceof IArmorItem && ARMOR_MATERIALS.containsValue(stack.getItem())){
-            material = ((IArmorItem) stack.getItem()).getArmorMaterial();
+            material = ((IArmorItem<?>) stack.getItem()).getArmorMaterial();
         }
         if (material == null) {
-            entityData.set(DATA_ARMOR_MATERIAL, "");
+            this.entityData.set(DATA_ARMOR_MATERIAL, null);
         } else {
-            entityData.set(DATA_ARMOR_MATERIAL, material.identifier.toString());
+            this.entityData.set(DATA_ARMOR_MATERIAL, material.identifier.toString());
         }
     }
 
@@ -118,7 +119,7 @@ public class MobWolf extends MobAnimal implements IItemHolding
     }
 
     @Override
-	public String getEntityTexture()
+	public @NotNull String getEntityTexture()
     {
         if(isWolfTamed())
         {
@@ -488,23 +489,15 @@ public class MobWolf extends MobAnimal implements IItemHolding
         return isWolfShaking;
     }
 
-    public float getShadingWhileShaking(float f)
+    public float getShadingWhileShaking(final float partialTick)
     {
-        return 0.75F + ((prevTimeWolfIsShaking + (timeWolfIsShaking - prevTimeWolfIsShaking) * f) / 2.0F) * 0.25F;
+        return 0.75F + MathHelper.lerp(this.prevTimeWolfIsShaking, this.timeWolfIsShaking, partialTick) / 8.0F;
     }
 
-    public float getShakeAngle(float f, float f1)
+    public float getShakeAngle(final float partialTick, final float offset)
     {
-        float f2 = (prevTimeWolfIsShaking + (timeWolfIsShaking - prevTimeWolfIsShaking) * f + f1) / 1.8F;
-        if(f2 < 0.0F)
-        {
-            f2 = 0.0F;
-        } else
-        if(f2 > 1.0F)
-        {
-            f2 = 1.0F;
-        }
-        return MathHelper.sin(f2 * MathHelper.PI) * MathHelper.sin(f2 * MathHelper.PI * 11F) * 0.15F * MathHelper.PI;
+        final float shakeTime = MathHelper.clamp((MathHelper.lerp(this.prevTimeWolfIsShaking, this.timeWolfIsShaking, partialTick) + offset) / 1.8F, 0, 1);
+        return MathHelper.sin(shakeTime * MathHelper.PI) * MathHelper.sin(shakeTime * MathHelper.PI * 11F) * 0.15F * MathHelper.PI;
     }
 
     public float getInterestedAngle(float f)
@@ -523,7 +516,7 @@ public class MobWolf extends MobAnimal implements IItemHolding
     {
         if(isWolfSitting())
         {
-            return 20;
+            return 40;
         } else
         {
             return super.getLookingTilt();
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobCreeper.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobCreeper.java
index 0e69f3d75..6d4881887 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobCreeper.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobCreeper.java
@@ -14,10 +14,10 @@ public class MobCreeper extends MobMonster
 {
     public static final int DATA_CREEPER_STATE = 16;
     public static final int DATA_POWERED = 17;
-    public MobCreeper(@Nullable World world)
+    public MobCreeper(@NotNull final World world)
     {
         super(world);
-        textureIdentifier = new NamespaceID("minecraft", "creeper");
+        setTextureIdentifier("minecraft", "creeper");
         scoreValue = 800;
         setSize(0.6F, 1.6F);
         mobDrops.add(new WeightedRandomLootObject(Items.SULPHUR.getDefaultStack(), 0, 2));
diff --git a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
index da5eb2dac..ce3b5801e 100644
--- a/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
+++ b/game/core/src/main/java/net/minecraft/core/entity/monster/MobGhast.java
@@ -37,7 +37,7 @@ public class MobGhast extends MobFlying
         aggroCooldown = 0;
         attackChargeO = 0;
         attackCharge = 0;
-        textureIdentifier = new NamespaceID("minecraft", "ghast");
+        setTextureIdentifier("minecraft", "ghast");
         setSize(4F, 7F);
         fireImmune = true;
         scoreValue = 1000;
@@ -53,9 +53,9 @@ public class MobGhast extends MobFlying
     }
 
     @Override
-    public String getEntityTexture()
+    public @NotNull String getEntityTexture()
     {
-        if (entityData.getByte(DATA_CHARGING) != 1)
+        if (this.entityData.getByte(DATA_CHARGING) != 1)
         {
             return super.getEntityTexture();
         }
@@ -68,7 +68,7 @@ public class MobGhast extends MobFlying
     @Override
     public @NotNull String getDefaultEntityTexture()
     {
-        if (entityData.getByte(DATA_CHARGING) != 1)
+        if (this.entityData.getByte(DATA_CHARGING) != 1)
         {
             return super.getEntityTexture();
         }
